<template>
	<section ref="panel" :class="$style.panel" @focusin="clearAutoadvanceInterval" @focusout="handleFocusout">
		<div :class="$style.transitionWrapper">
			<div v-if="moduleTitle" :class="$style.titleWrapper">
				<h2 ref="title" :class="[$style.title, { [$style.hideTitle]: hideModuleTitle }]">
					{{ moduleTitle }}
				</h2>
			</div>
			<transition name="fade-in-out">
				<div :key="activeItemIndex" :class="sharedStyle.statisticsImage">
					<BaseImage
						role="presentation"
						aria-hidden="true"
						:image="null"
						:images="{ large: activeItem.imageDesktop }"
						sizes="100vw"
						compression-level="low"
						alt=""
					/>
				</div>
			</transition>
		</div>

		<span :class="sharedStyle.separator" />

		<div :class="$style.navigationAndInformation">
			<div :class="$style.navigation">
				<!-- eslint-disable-next-line vuejs-accessibility/interactive-supports-focus -->
				<ul
					class="u-nolist"
					role="tablist"
					aria-label="Statistics"
					aria-orientation="vertical"
					@keydown.up.prevent="($event) => navigateTabs($event, 'up')"
					@keydown.down.prevent="($event) => navigateTabs($event, 'down')"
				>
					<li
						v-for="({ navTitle }, i) in items"
						:id="`tab-${i}-desktop`"
						:key="navTitle"
						ref="tabs"
						:class="[$style.navigationItem, { [$style.isActive]: navTitle === activeItem.navTitle }]"
						role="tab"
						:data-index="i"
						:aria-controls="`tab-panel-${i}-desktop`"
						:aria-selected="String(activeItemIndex === i)"
						:tabindex="navTitle === activeItem.navTitle ? 0 : -1"
						@focus="switchActiveItem(i)"
					>
						<div v-if="items.length > 1" :class="$style.iconWrapper">
							<svg :class="$style.icon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 20">
								<polygon
									v-if="activeItem.navTitle == navTitle"
									points="37.97 0 37.24 0.9 47.56 9.39 0 9.39 0 10.55 47.43 10.55 37.23 19.11 37.98 20 50 9.91 37.97 0"
								/>
							</svg>
						</div>
						<div :class="$style.right">
							{{ navTitle }}
						</div>
					</li>
				</ul>
			</div>

			<div
				:id="`tab-panel-${activeItemIndex}-desktop`"
				:aria-labelledby="`tab-${activeItemIndex}-desktop`"
				role="tabpanel"
				:class="$style.tabPanel"
				tabindex="0"
			>
				<div :class="$style.transitionWrapper">
					<transition name="fade-in-out">
						<div :key="activeItemIndex" :class="$style.informationWrapper">
							<div :class="$style.informationItemWrapper">
								<div :class="$style.informationItem">
									<h3 :class="sharedStyle.heading"
										>{{ activeItem.heading
										}}<button
											v-if="hasFootnote"
											:aria-label="hasFootnote ? 'Skip to footnote' : null"
											:tabindex="hasFootnote ? '0' : null"
											@click="focusOnFootnote"
											>*</button
										>
									</h3>
									<div v-rich-content :class="sharedStyle.information" v-html="activeItem.content" />
								</div>
							</div>

							<div :class="$style.informationItemWrapper">
								<div :class="$style.informationItem">
									<div
										v-if="$hasRichText(activeItem.testingDetails)"
										v-rich-content
										:class="[sharedStyle.detailsAndFootnote, sharedStyle.details]"
										v-html="activeItem.testingDetails"
									/>
									<div
										v-if="hasFootnote"
										ref="footnote"
										v-rich-content
										role="doc-footnote"
										tabindex="-1"
										:class="[sharedStyle.detailsAndFootnote, sharedStyle.footnote]"
										v-html="activeItem.footnote"
									/>
								</div>
							</div>
						</div>
					</transition>
				</div>
			</div>
		</div>
	</section>
</template>

<script>
import { mapState } from 'vuex';

let observer;

export default {
	props: {
		moduleTitle: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			required: true,
		},

		sharedStyle: {
			type: Object,
			required: true,
		},

		autoadvance: {
			type: Boolean,
			required: true,
		},

		autoadvanceIntervalDelay: {
			type: Number,
			required: true,
		},
	},

	data: () => ({
		activeItemIndex: 0,
		hideModuleTitle: false,
		hideModuleTitleTimeout: null,
		autoadvanceInterval: null,
	}),

	computed: {
		...mapState('screen', ['large']),

		activeItem() {
			return this.items[this.activeItemIndex];
		},

		hasFootnote() {
			return this.$hasRichText(this.activeItem.footnote);
		},
	},

	watch: {
		large(v) {
			if (v) this.connect();
			else this.disconnect();
		},
	},

	mounted() {
		if (this.large) this.connect();
	},

	beforeDestroy() {
		this.disconnect();
	},

	methods: {
		connect() {
			observer = new IntersectionObserver(this.observerCallback);

			if (this.moduleTitle) observer.observe(this.$refs.title);
			observer.observe(this.$refs.panel);
		},

		disconnect() {
			this.clearhideModuleTitleTimeout();
			if (this.autoadvance) this.clearAutoadvanceInterval();
			if (observer) observer.disconnect();
		},

		switchActiveItem(currentIndexOrDirection, didAutoadvance) {
			const { activeItemIndex } = this;
			let index = currentIndexOrDirection;
			if (typeof currentIndexOrDirection === 'string') {
				index = currentIndexOrDirection === 'next' ? activeItemIndex + 1 : activeItemIndex - 1;
			}

			if (index > this.items.length - 1) {
				this.activeItemIndex = 0;
			} else if (index < 0) {
				this.activeItemIndex = this.items.length - 1;
			} else {
				this.activeItemIndex = index;
			}

			if (this.autoadvance && !didAutoadvance) {
				this.resetAutoadvanceInterval();
			}
		},

		hideModuleTitleAfterTimeout() {
			this.hideModuleTitle = false;

			this.clearhideModuleTitleTimeout();

			this.hideModuleTitleTimeout = setTimeout(() => {
				this.hideModuleTitle = true;
				this.hideModuleTitleTimeout = null;
			}, 3500);
		},

		navigateTabs(event, direction) {
			const { target } = event;
			const { tabs } = this.$refs;
			const increment = direction === 'up' ? -1 : 1;

			if (tabs[Number(target.dataset.index) + increment]) {
				tabs[Number(target.dataset.index) + increment].focus();
			} else if (direction === 'up') {
				tabs[tabs.length - 1].focus();
			} else if (direction === 'down') {
				tabs[0].focus();
			}
		},

		startAutoadvance() {
			this.autoadvanceInterval = setInterval(() => {
				this.switchActiveItem(this.activeItemIndex + 1, true);
			}, this.autoadvanceIntervalDelay);
		},

		resetAutoadvanceInterval() {
			this.clearAutoadvanceInterval();
			this.startAutoadvance();
		},

		clearTimeFunction(clearFn, prop) {
			const { [prop]: timeProp } = this;
			if (timeProp) {
				clearFn(timeProp);
				this[prop] = null;
			}
		},

		clearhideModuleTitleTimeout() {
			this.clearTimeFunction(clearInterval, 'hideModuleTitleTimeout');
		},

		clearAutoadvanceInterval() {
			this.clearTimeFunction(clearInterval, 'autoadvanceInterval');
		},

		handleFocusout(e) {
			if (!this.autoadvance) return;

			const { panel } = this.$refs;
			if (!panel.contains(e.relatedTarget)) {
				this.resetAutoadvanceInterval();
			}
		},

		observerCallback(entries) {
			entries.forEach(({ isIntersecting, target }) => {
				const isTitle = target.nodeName.startsWith('H');
				if (!isIntersecting) {
					if (isTitle) {
						this.clearhideModuleTitleTimeout();
					} else if (!isTitle && this.autoadvance) {
						this.clearAutoadvanceInterval();
					}

					return;
				}

				if (isTitle && !this.hideModuleTitleTimeout) {
					this.hideModuleTitleAfterTimeout();
				} else if (!isTitle && this.autoadvance) this.resetAutoadvanceInterval();
			});
		},

		focusOnFootnote() {
			if (this.hasFootnote) {
				this.$refs.footnote.focus();
			}
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.panel {
	padding: 6.5rem 8rem 6.1rem;

	@include below('large') {
		display: none;
	}
}

.titleWrapper {
	position: absolute;
	top: 0;
	left: 0;
	z-index: 1;
	display: flex;
	align-items: flex-start;
	justify-content: flex-end;
	width: 100%;
	height: 100%;
	padding: 2rem 4.3rem 0.4rem;

	@include above('large') {
		padding: 0;
	}
}

.title {
	@include use-text-style('heading-700');

	padding: 1em 0 0;
	font-family: font-family('secondary');
	line-height: 1.1333;
	text-align: center;
	opacity: 1;
	transition: opacity time('slow') ease('in');
}

.hideTitle {
	opacity: 0;
}

.navigationAndInformation {
	display: grid;
	grid-template-columns: 5fr 8fr;
	gap: 4rem;
	text-align: left;

	@include above('xlarge') {
		grid-template-columns: 3fr 4fr;
	}
}

.navigation {
	@include use-text-style('type-500');

	margin: 0;
	font-weight: 300;
	line-height: 1.38;
}

.navigationItem {
	display: flex;
	align-items: center;
	cursor: pointer;

	&.isActive {
		font-weight: 400;
	}
}

.iconWrapper {
	flex: 0 0 auto;
	padding-right: size('s');
	visibility: hidden;
	opacity: 0;

	.navigationItem.isActive & {
		visibility: visible;
		opacity: 1;
	}
}

.icon {
	display: block;
	width: 4.3rem;
	height: 2rem;
	fill: currentColor;
}

.tabPanel {
	flex: 1;
	justify-self: flex-end;
	width: 100%;
	max-width: 70.8rem;
}

.transitionWrapper {
	position: relative;
}

.informationWrapper {
	display: grid;
	grid-template-columns: auto 24.5rem;
	gap: 4rem;
}

.informationItemWrapper {
	&:first-child {
		justify-self: flex-start;
	}

	&:last-child {
		justify-self: flex-end;
	}
}

.informationItem {
	max-width: 35rem;
	margin: auto;
}
</style>
